function [Basis,S_ind,T_ind,Gbar,eps_star] = empIntAlg(G,tol)
  
%% Find first basis vector

   Q = 1;  
  % Linf norm (and index) of g for all parameter values
   [supNorms, supNorm_ind] = max(abs(G));
  % maximum norm (index) over all parameter values
   [~, S_ind(Q)] = max(supNorms);
  % basis vector: argmax of norm
   q = G(:, S_ind);
  % interpolation point: maximum of abs(q)
   T_ind(Q,1) = supNorm_ind(S_ind);
  % normalization
   Basis(:,Q) = q / q(T_ind(Q));
  % interpolation matrix: basis vectors at interpolation points
   Gbar = Basis(T_ind,:);

%% start greedy 
  eps_star = [];
  while(1)
  % LInf error (and index) of g-gQ for all parameter values
    [supNorms, supNorm_ind] = max(abs(G - Basis*(Gbar\G(T_ind,:))));

  % maximum norm (and index) over all parameter values
    [eps_star(end+1), S_ind(end+1)] = max(supNorms);
    [Q eps_star(end)]
    
    if(eps_star(Q) < tol)
        break
    end

  % basis vector: argmax of norm
    q = G(:,S_ind(end)) - Basis*(Gbar\G(T_ind,S_ind(end)));
    
  % interpolation point: maximum of abs(q)
    T_ind(end+1,1) = supNorm_ind(S_ind(end));
  % normalization
    Basis(:,end+1) = q/q(T_ind(end));
  % interpolation matrix: basis vectors at interpolation points
    Gbar = Basis(T_ind,:);
    
    Q = Q+1;
  end