function [EIM_coeffs,errEst] = getEIMCoeffs(EIM,Q,Qprime, varargin)

  mu = varargin;
  
  Qprime = min(Qprime,EIM.Q_max);
  Q = min(Q, Qprime);
  x = EIM.T;

% evaluate g for all values of mu in all magic points (stored in x)
  X = cellfun(@(x) repmat(x(1:Qprime),1,numel(mu{1})),x,'UniformOutput',false);
  Mu = cellfun(@(mu) repmat(mu(:)',Qprime,1),mu,'UniformOutput',false);
  G = EIM.g(X{:},Mu{:});

if(nargout < 2)
% compute empirical interpolation coefficients  
  EIM_coeffs = EIM.Gbar(1:Q,1:Q)\G(1:Q,:);
else
  % compute empirical interpolation coefficients  
  alpha = EIM.Gbar(1:Qprime,1:Qprime)\G(1:Qprime,:);
  
  EIM_coeffs = alpha(1:Q,:);
  
% error estimator for Q' 
  errEst = sum(abs(alpha(Q+1:Qprime,:)),1);
end